#ifndef MAP_OPTIONS_H
#define MAP_OPTIONS_H

enum ACTION { bsp, vis, rad };

struct map_opt {
	char *game;
	unsigned int threads;
	bool verbose;
	bool info;
	enum ACTION action;
};

struct bsp_opt {
	float microvolume;
	float subdivide_size;
	int block_xl, block_xh;
	int block_yl, block_yh;
	char *outbase;
	bool glview;
	bool draw;
	bool noweld; /** @todo change all these to 'weld', 'junc', etc? */
	bool nocsg;
	bool notjunc;
	bool nowater;
	bool noopt;
	bool noprune;
	bool nofill;
	bool nomerge;
	bool nosubdiv;
	bool no_detail;
	bool full_detail;
	bool only_ents;
	bool leak_test;
	bool verbose_entities;
};

struct vis_opt {
	int test_level;
	bool fast_vis;
	bool nosort;
	bool in_base;
	bool out_base;
};

struct rad_opt {
	bool dump_patches;
	int num_bounces;
	bool extra_samples;
	int sub_divisions;
	float direct_scale;
	float entity_scale;
	bool glview;
	bool no_pvs;
	float ambient;
	float max_light;
	char *in_base;
	char *out_base;
};

#endif /* MAP_OPTIONS_H */
