/* We only need to use this macro and print will work in kernel mode
 * and non-kernel mode. */
#include <stdio.h>

/** disable all output but error messages if set */
char quiet;

#ifdef __KERNEL__
#define PRINT(x...) kprintf( x )
#else
#define PRINT(x...) \
  if( quiet == 0 ) { \
    fprintf( stdout, x ); \
  }
#endif

/** EPRINT should print out regardless ("Error Print") */
#ifdef __KERNEL__
#	define EPRINT(x...) kprintf( x );
#else
#	define EPRINT(x...) fprintf( stderr, x );
#endif
