#ifndef _REGS_H_
#define _REGS_H_

#include <ktypes.h>

/* These defines are used durring system calls to get their arguments from the
 * registers.  This interface should make the system calls not dependent on
 * register names in different archs. */
#define REG_ACCUM(x) (x->eax)
#define REG_ARG_1(x) (x->ebx)
#define REG_ARG_2(x) (x->ecx)
#define REG_ARG_3(x) (x->edx)

/* This struct is ordered specifically the way registers are stored on the stack
 * upon an interrupt. */
struct regs {
  uint16 gs __attribute__((packed));
  uint16 fs __attribute__((packed));
  uint16 es __attribute__((packed));
  uint16 ds __attribute__((packed));
  uint32 edi __attribute__((packed)); 
  uint32 esi __attribute__((packed));
  uint32 ebp __attribute__((packed)); 
  uint32 edx __attribute__((packed)); 
  uint32 ebx __attribute__((packed)); 
  uint32 ecx __attribute__((packed));
  uint32 eax __attribute__((packed));
};

#endif /* _REGS_H_ */
