#define __ASM__
#include <sched.h>

  .data
waiting:
  .string "waiting %d.\n"

	.global mutex_lock

	.text
	.align 4

/** locks a binary semaphore.
 * takes a single (32bit) argument -- a ptr to a mutex_t
 * THIS CODE IS SPECIFIC TO THE LAYOUT OF mutex_t -- IF YOU CHANGE THAT
 * YOU MUST CHANGE THIS ASM! */
mutex_lock:
	pushl %ebp
	movl %esp, %ebp

	pushl %edx
	movl 8(%ebp), %edx # get mutex_t* into edx
again:
	xorl %eax, %eax    # zero out eax
	xchgl (%edx),%eax  # swap mutex w/ eax
	orl %eax, %eax     # if eax is 0 ...
	je block           #   ... add to queue and block
	jmp done           #   ... otherwise we are done

block:                # add to queue and block this process
  /* Wait the current process. */
  pushl curproc
  pushl $waiting
  call kprintf
  addl $8, %esp

  pushl 4(%edx)
  call wait
  addl $4, %esp

	/* when schedule finally returns, we try and acquire the lock again */
	jmp again

done:
	popl %edx
	popl %ebp
	ret
