#include <device.h>
#include <retval.h>
#include <config/kern.h>

/* Current index into the device table. */
static uint32 dev_index = 0;

/* Table of all devices. */
device_t *devtab[DEVICE_MAX];

int device_add( device_t *d )
{
  if( dev_index == DEVICE_MAX ) 
    return RET_FAILURE;

  devtab[dev_index++] = d;
  kprintf( "%s%d: added to global device table\n", d->name, d->minor );

  return RET_SUCCESS;  
}
