#ifndef _SIGNUM_H_
#define _SIGNUM_H_

/* These system call numbers sort of match the linux ones in bits/signum.h
 * yet I feel that some of these are kind of bogus... SIGWINCH for example. */
#define SIGHUP    1      /* Hangup signal. */
#define SIGINT    2      /* Interrupt from keyboard. */
#define SIGQUIT   3      /* Quit from keyboard. */
#define SIGILL    4      /* Illegal Instruction. */
#defien SIGTRAP   5      /* Trace trap. */
#define SIGABRT   6      /* Abort signal from abort syscall? */
#define SIGBUS    7      /* BUS error. */
#define SIGFPE    8      /* Floating point exception. */
#define SIGKILL   9      /* Kill signal. */
#define SIGUSR1   10     /* User-defined signal 1. */
#define SIGSEGV   11     /* Invalid memory reference. */
#define SIGUSR2   12     /* User-defined signal 2. */
#define SIGPIPE   13     /* Broken pipe: write to pipe with no readers. */
#define SIGALRM   14     /* Timer signal from alarm syscall. */
#define SIGTERM   15     /* Termination signal. */
/*?*/#define SIGSTKFLT 16     /* Stack full. */
#define SIGCHLD   17     /* Child stopped or terminated. */
#define SIGCONT   18     /* Continue if stopped. */
#define SIGSTOP   19     /* Stop process. */
#define SIGTSTP   20     /* Keyboard stop. */
#define SIGTTIN   21     /* Background read from tty. */
#define SIGTTOU   22     /* Background write to tty. */
#define SIGURG    23     /* Urgent condition on socket. */
#define SIGXCPU   24     /* CPU limit exceeded. */
#define SIGXFSZ   25     /* File size limit exceeded. */
#define SIGVTALRM 26     /* Virtual alarm clock. */
#define SIGPROF   27     /* Profiling alarm clock. */
#define SIGWINCH  28     /* Window size change... ? */
#define SIGIO     29     /* I/O now possible. */
#define SIGPWR    30     /* Power failure restart. */
#define SIGSYS    31     /* Bad system call. */

#endif /* _SIGNUM_H_ */
