#ifndef _SYS_H_
#define _SYS_H_

void sys_exit( int status );
pid_t fork(void);
ssize_t read( int fd, void *buff, size_t nbytes );
ssize_t write( int fd, void *buff, size_t nbytes );
int open( const char *path, int flags, mode_t mode );
pid_t waitpid( pid_t wpid, int *status, int options );
int creat( const char *pathname, mode_t mode );
int link( const char *name1, const char *name2 );
int unlink( const char *path );
int execve( const char *path, char *const argv[], char *const envp[] );
int chdir( const char *path );
time_t time( time_t *t );
int mknod( const char *pathname, mode_t mode, dev_t dev );
int chmod( const char *path, mode_t mode );
int chown( const char *path, uid_t owner, gid_t group );
/* break. */
int stat( const char *file_name, struct stat *buff );
off_t lseek( int fildes, off_t offset, int whence );
pid_t getpid(void);
int mount( const char *source, const char *target, const char *filesystemtype,
           unsigned long mountflags, const void *data );
int umount( const char *target );
int setuid( uid_t uid );
uid_t getuid(void);
int stime( time_t *t );
/* ptrace */
unsigned int alarm( unsigned int seconds );
int fstat( int fd, struct stat *buf );
int pause(void);
int utime( const char *filename, const struct utimebuf *buf );
/* stty */
/* gtty */
int access( const char *pathname, int mode );
int nice( int inc );
int ftime( struct timeb *tp );
void sync(void);
int kill( pid_t pid, int sig );
int rename( const char *oldpath, const char *newpath );
int mkdir( const char *pathname, mode_t mode );
int rmdir( const char *pathname );
int dup( int oldfd );
int pipe( int filedes[2] );
clock_t times( struct tms *buf );
/* prof */
int brk( void *end_data_segment );
int setgid( gid_t gid );
gid_t getgid(void);
sighandler_t signal( int signum, sighandler_t handler );
uid_t geteuid(void);
gid_t getegid(void);
int acct( const char *filename );
/* phys? */
/* lock */
int ioctl( int d, int request, ... );
int fcntl( int fd, int cmd );
/* mpx */
int setpgid( pid_t pid, pid_t pgid );
long ulimit( int cmd, long newlimit );
int uname( struct utsname *buf );
mode_t umask( mode_t mask );
/* umask is syscall 60... since I won't implement these yet, I can type them up
 * later. */

endif /* _SYS_H_ */
