#ifndef _CONSOLE_H_
#define _CONSOLE_H_

#include <device.h>
#include <init.h>

typedef uint32 (*conrfun_t)( uint8* buff, uint32 len );
typedef uint32 (*conwfun_t)( uint8* buff, uint32 len );

typedef struct {
  char *name;   
  conrfun_t read;
  conrfun_t write;
  int (*init)(void); 
  uint32 priority;
} console;

console *cur_con;

/* Initialize the console. */
int init_console(void);

/* Returns a pointer to the console with the given name, or NULL. */
console *get_console( char *name );

#endif /* _CONSOLE_H_ */
