#ifndef _DEVICE_H_
#define _DEVICE_H_

#include <kstdio.h>
#include <ktypes.h>
#include <fs.h>
#include <queue.h>

/* Device major numbers. */
#define MAJOR_CHAR_UNNAMED 0
#define MAJOR_BLOCK_UNNAMED 0
#define MAJOR_CHAR_MEM 1
#define MAJOR_BLOCK_RAMDISK 1
#define MAJOR_CHAR_PTTY 2
#define MAJOR_BLOCK_FD 2
#define MAJOR_CHAR_PTTY_SLAVE 3
#define MAJOR_BLOCK_IDE 3
#define MAJOR_CHAR_CONS 4

#define MAJOR_CHAR_KBD 5

typedef struct {
  void* dev_spec;         /* Device specific data. */
  char *name;             /* Device's name. */
  uint8 minor;            /* Devcie's minor number. */
  uint8 major;            /* Devcie's major number (is this needed?). */
  file_ops_t fops;        /* File operations. */
  struct queue *wait_q;   /* Procs waiting for I/O to complete on this dev. */

} device_t; 

/* Adds a device to the device table. */
int device_add( device_t *d );

#endif /* _DEVICE_H_ */
