/** Routines concerning kernel semaphore operations.
 * Currently ix86-only -- requires the 'cmpxchg' instruction!
 *
 * Moved to include/sem.h.  It should be here so that we can have a general
 * interface.  -- Ethan */
#ifndef SEM_H
#define SEM_H

#include <ktypes.h>
struct queue;

typedef struct mutex {
	uint32 lock;
	struct queue *wait_q;
} mutex_t;

typedef struct semaphore {
	struct mutex m;
	int value;
  struct queue *wait_q;
} sem_t;

/** initializes a semaphore -- must be called before trying to use the
 * semaphore */
void sem_init(sem_t *, uint32 r);

/** locks a semaphore */
void sem_lock(sem_t *);

void sem_unlock(sem_t *);

#endif /* SEM_H */
