#ifndef _SYSCALL_H_
#define _SYSCALL_H_

#include <ktypes.h>
#include <common/types.h>
#include <common/signal.h>
#include <regs.h>

typedef int(*syscallfun_t)( struct regs *r );
/* This function picks the correct syscall to preform based on the registers
 * then calls it with the appropriate arguments. */
void do_syscall( struct regs *r );

/* Make sure these are in order of number. */
#define NUM_SYSCALLS 20

/* 1 */
int sys_exit( struct regs *r );

/* 20 */
int sys_getpid( struct regs *r );


#endif /* _SYSCALL_H_ */
