#include <kstdlib.h>
#include <kstdio.h>
#include <cpu.h>
#include <init.h>
#include <console.h>
#include <interrupt.h>
#include <kstring.h>
#include <memutil.h>
#include <memman.h>
#include <sched.h>
#include <process.h>
#include <panic.h>
#include <kthread.h>
#include <sem.h>

/* Max length of kernel arguments. */
#define ARG_LEN 50

#include <test_code.h>

/* This binary is a program that prints the value of a long in memory that is
 * set to 5555_decimal (This is usefull to demonstrate the process calculating
 * the address correctly.  Then it does a getpid, print loop for 10 rounds.
 */
char test_proc[] = {
0xbe, 0x36, 0x00, 0x00, 0x00, 0xad, 0x89, 0xc3, 0xb8, 0x02, 0x00, 0x00, 0x00, 0xcd, 0x80, 0xb9,
0x0a, 0x00, 0x00, 0x00, 0xb8, 0x14, 0x00, 0x00, 0x00, 0xcd, 0x80, 0xbf, 0x36, 0x00, 0x00, 0x00,
0xab, 0x31, 0xc0, 0xbe, 0x36, 0x00, 0x00, 0x00, 0xad, 0x89, 0xc3, 0xb8, 0x02, 0x00, 0x00, 0x00,
0xcd, 0x80, 0x49, 0x75, 0xdf, 0xc3, 0xb3, 0x15, 0x00, 0x00
};
uint32 test_proc_len = 58;

static sem_t s;

void test() {
	int i, j;

	for(i=0; i < 10; ++i) {
    kprintf( "[%d] requesting lock\n", curproc );
		sem_lock(&s);
      kprintf( "[%d] has lock\n", curproc );
      for( j = 0; j < 0xffff; j++ );
    kprintf( "[%d] releasing lock\n", curproc );
		sem_unlock(&s);
    for( j = 0; j < 0xffff; j++ );
	}
}

/* Create a simple _cheating_ init process and add it to the scheduler. */
static void init_process()
{
  static process_t p1, p2;
  create_process( &p1, &test_proc, test_proc_len );
  create_process( &p2, &test_process_1, ((uint32)&test_process_1_end -
                                        (uint32)&test_process_1) );
}

extern uint32 get_free_frame( uint32* );

int kmain( uint32 _memsize, char *_arg )
{
  char args[ARG_LEN];
  uint32 i;

  /* Make sure to copy this string over to our kernel's memory so that we
   * do not stomp on it. */
  memory_size = _memsize;
  kstrcpy( args, _arg );

  /*for( i = 0; i < 0xffffff; i++ );*/

  /* A console should not be REQUIRED, however, it is... so there. */
  if( init_console() == RET_FAILURE ) { while(1) { halt(); } }

  kprintf( "kernel parameters: [%s]\n", args );

  INITIALIZE(init_cpu, "Unable to initializing cpu." );

  /* Calls device init functions that do not need to be, otherwise, explicitly
   * called. */
  enable();
  call_init_functs();

  init_sched();
  init_process();   /* for testing only, we really should load an init prog. */
  scheduler_start();

  while( 1 ) { halt(); }

  return 0;
}

/* This function is called after the init process is completed.
 * This will happen on a system halt, reboot, or anything else that will
 * cleanly shut down the operating system too. */
void kend()
{
  enable(); while( 1 ) { halt(); }
}
