#include <syscall.h>
#include <regs.h>
#include <sched.h> /* process_kill, curproc */
#include <kstdio.h>
#include <kstdlib.h>

/* 
 * TEMPORARY:
 * Print curproc. 
 */
int sys_temp( struct regs *r )
{
  kprintf( "%d", REG_ARG_1(r) );

  return 1;
}

static syscallfun_t syscalltab[] = {
/* 00 */  NULL,
/* 01 */  sys_exit,
/* 02 */  sys_temp, /* this should be fork but I need to have a print for now */
/* 03 */  NULL,
/* 04 */  NULL, 
/* 05 */  NULL, 
/* 06 */  NULL, 
/* 07 */  NULL, 
/* 08 */  NULL, 
/* 09 */  NULL, 
/* 10 */  NULL, 
/* 11 */  NULL, 
/* 12 */  NULL, 
/* 13 */  NULL, 
/* 14 */  NULL, 
/* 15 */  NULL, 
/* 16 */  NULL, 
/* 17 */  NULL, 
/* 18 */  NULL, 
/* 19 */  NULL, 
/* 20 */  sys_getpid, 
};

void do_syscall( struct regs *r )
{
  word_t i = REG_ACCUM(r);

  /* NOTE: the +1 is because sys_temp and will be removed. */
  if( i > NUM_SYSCALLS+1 || syscalltab[i] == NULL ) {
    kprintf( "pid %d: invalid system call %d terminating.\n", curproc, i );
    process_kill( curproc ); 
  }

  REG_ACCUM(r) = syscalltab[i]( r );
}

/* 1 */
int sys_exit( struct regs *r )
{
  process_kill( curproc );  

  return REG_ARG_1(r);
}

/* 20 */
int sys_getpid( struct regs *r )
{
  return curproc;
}
