/*
 * trace.h contains declarations for the arch specific process trace functions.
 */

#ifndef _TRACE_H_
#define _TRACE_H_

#if defined(HAVE_CONFIG_H)
#include <config.h>
#endif /* HAVE_CONFIG_H */

#include <sys/types.h>

/*
 * Traces the process with the given pid.  When the given process traps with an
 * open system call entry the open_entry function will be called.  When the
 * given process traps with an open system call exit the open_exit function 
 * will be called.
 *
 * returns negative on error, and non-negative on success.
 */
int trace_syscalls(const pid_t);

/*
 * Sets the current process to allow tracing.
 */
void trace_proc();

#endif /* _TRACE_H_ */
